#if !defined(_CLOCK_H)
#define TOOL_CLOCK_H

#if !defined(OWL_CONTROL_H)
# include <owl/control.h>
#endif

//
// class TClock
// ~~~~~ ~~~~~~
//
class TClock : public TControl {
  public:
    // Constructors
    //
    TClock(TWindow* parent, int id, const char* title, int x, int y,
           int w, int h, TModule* module = 0);
    TClock(TWindow* parent, int resourceId, TModule* module = 0);

    // Destructor
    //
   ~TClock();

    void SetupWindow  ();
    void CleanupWindow();

  protected:
    char* GetClassName();

    bool EvEraseBkgnd(HDC hDC);

    void EvPaint();

    void EvSize(uint sizeType, TSize& size);

    void EvTimer(uint timerId);

  private:
    int x, y;          // Center
    int r;             // Radius

    int h, m, s;       // Hour, Minute and Second

    double scale;      // Scale if resized

    TColor bkColor;    // Background color

    TRect clientRect;  // Client part of our control

    TMemoryDC* memDC;

    void AdjustParams();

    void GetTime();

    void Plot(TDC& dc);

  DECLARE_RESPONSE_TABLE(TClock);
};

// TClock inline implementation
//
inline char*
TClock::GetClassName()
{
  return "TOOL_CLOCK";
}

inline bool
TClock::EvEraseBkgnd(HDC /* hDC */)
{
  return true;
}

#endif  // TOOL_CLOCK_H
